'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _rsync = require('rsync');

var _rsync2 = _interopRequireDefault(_rsync);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _os = require('os');

var _util = require('./util');

function bigSync(project) {
    var log = (0, _util.generateLog)(project.project, (0, _os.hostname)());

    function consoleLogFromBuffer(buffer) {
        log(buffer.toString());
    }

    var params = _lodash2['default'].isPlainObject(_lodash2['default'].get(arguments, 1)) ? _lodash2['default'].get(arguments, 1) : {};

    var onComplete = _lodash2['default'].isFunction(_lodash2['default'].last(arguments)) ? _lodash2['default'].last(arguments) : _lodash2['default'].noop;

    var rsync = new _rsync2['default']().shell('ssh').flags('az').exclude(project.excludes).source((0, _util.ensureTrailingSlash)(project.sourceLocation)).set('delete').destination(project.username + '@' + project.hostname + ':' + project.destinationLocation);

    if (params.dry) {
        rsync.set('dry-run');
    }

    if (params.debug) {
        rsync.progress();
        rsync.output(consoleLogFromBuffer, consoleLogFromBuffer);
    }

    rsync.execute(onComplete);
};

exports['default'] = bigSync;
module.exports = exports['default'];