'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _packageJson = require('../package.json');

var _update = require('./update');

var _util = require('./util');

var _commands = require('./commands');

var _commands2 = _interopRequireDefault(_commands);

var config = (0, _util.getConfig)();

(0, _commands2['default'])(_commander2['default'], config);

function SickSync() {
    _commander2['default'].version(_packageJson.version).usage('<command> [options]').parse(process.argv);

    // Run help if no command is provided
    if (!process.argv.slice(2).length) {
        (0, _util.printLogo)();
        _commander2['default'].outputHelp();
    }

    // Run/Display update notifications
    (0, _update.check)();
    (0, _update.notify)();
};

exports['default'] = SickSync;
module.exports = exports['default'];