'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _chokidar = require('chokidar');

var _events = require('events');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _untildify = require('untildify');

var _untildify2 = _interopRequireDefault(_untildify);

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

var _confConstants = require('../../conf/constants');

var _confConstants2 = _interopRequireDefault(_confConstants);

var _confEvents = require('../../conf/events');

var _confEvents2 = _interopRequireDefault(_confEvents);

var fsEvents = _confEvents2['default'].FS.LOCAL;

var FSHelper = (function (_EventEmitter) {
    _inherits(FSHelper, _EventEmitter);

    function FSHelper(params) {
        _classCallCheck(this, FSHelper);

        _get(Object.getPrototypeOf(FSHelper.prototype), 'constructor', this).call(this);

        this._sourceLocation = params.sourceLocation;
        this._excludes = params.excludes || [];
        this._followSymLinks = params.followSymlinks || false;
        this._baseDir = _path2['default'].parse(this._sourceLocation).base + '/';
        this._paused = true;

        // Node/watcher only work with full file-paths (no ~'s)
        this._watcher = (0, _chokidar.watch)((0, _untildify2['default'])(this._sourceLocation), {
            ignored: this._excludes,
            persistent: true,
            followSymlinks: this._followSymlinks,
            ignoreInitial: true
        }).on('all', _util2['default'].rebounce(this.onFileChange.bind(this), _lodash2['default'].partial(this.emit, fsEvents.LARGE), _confConstants2['default'].NUM_FILES_FOR_RSYNC, _confConstants2['default'].FILE_CHANGE_COOLDOWN_MS));
    }

    _createClass(FSHelper, [{
        key: 'onFileChange',
        value: function onFileChange(evt, sourcepath) {
            var relativepath = sourcepath.split(this._baseDir)[1],
                localpath = this._sourceLocation + relativepath,
                fileContents = null;

            if (this._paused || _util2['default'].isExcluded(relativepath, this._excludes)) return;
            if (evt === 'add' || evt === 'change') fileContents = _fs2['default'].readFileSync(sourcepath).toString();

            this.emit(fsEvents.CHANGE, {
                changeType: evt,
                relativepath: relativepath,
                localpath: localpath,
                contents: fileContents
            });
        }
    }, {
        key: 'pauseWatch',
        value: function pauseWatch() {
            this._paused = true;
        }
    }, {
        key: 'watch',
        value: function watch() {
            this._paused = false;
        }
    }]);

    return FSHelper;
})(_events.EventEmitter);

exports['default'] = FSHelper;
module.exports = exports['default'];