'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _events = require('events');

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

var _confEvents = require('../../conf/events');

var _confText = require('../../conf/text');

var RemoteHelper = (function (_EventEmitter) {
    _inherits(RemoteHelper, _EventEmitter);

    function RemoteHelper(params) {
        _classCallCheck(this, RemoteHelper);

        _get(Object.getPrototypeOf(RemoteHelper.prototype), 'constructor', this).call(this);

        this._secret = params.secret;
        this._webSocketPort = params.websocketPort;
        this._username = params.username;
        this._hostname = params.hostname;
        this._prefersEncrypted = params.prefersEncrypted || false;
        this._debug = params.debug || false;
    }

    _createClass(RemoteHelper, [{
        key: '_startRemoteSicksync',
        value: function _startRemoteSicksync(ssh) {
            var context = this;

            ssh.stdin.write(['sicksync remote', '-s', context._secret, '-p', context._webSocketPort, context._prefersEncrypted ? '-e' : '', context._debug ? '-d' : '', '\n'].join(' '));
        }
    }, {
        key: 'start',
        value: function start() {
            var context = this;
            var bootSicksync = _lodash2['default'].once(this._startRemoteSicksync.bind(this));
            var ssh = _util2['default'].shellIntoRemote(this._username + '@' + this._hostname);

            ssh.stdout.on('data', function (data) {
                var message = data.toString();

                // Boot sicksync (once!)
                bootSicksync(ssh);

                // If we get a 'ready' flag back from the server, emit a ready event
                if (_lodash2['default'].contains(message, _confText.SERVER_ON_READY)) return context.emit(_confEvents.REMOTE.READY);

                // If the message contains the devboxes name, emit the message
                if (_lodash2['default'].contains(message, context._secret)) {
                    var cleanedMessage = message.replace(context._secret, '').replace('\n', '');

                    return context.emit(_confEvents.REMOTE.MESSAGE, cleanedMessage);
                }

                // Not in $PATH
                if (_lodash2['default'].contains(message, 'no sicksync in')) {
                    return context.emit(_confEvents.REMOTE.NOT_FOUND, message);
                }

                // Command not found :(
                /* istanbul ignore else */
                if (_lodash2['default'].contains(message, 'command not found')) {
                    return context.emit(_confEvents.REMOTE.ERROR, message);
                }
            });
        }
    }]);

    return RemoteHelper;
})(_events.EventEmitter);

exports['default'] = RemoteHelper;
module.exports = exports['default'];