'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ws = require('ws');

var _ws2 = _interopRequireDefault(_ws);

var _events = require('events');

var _remoteHelper = require('./remote-helper');

var _remoteHelper2 = _interopRequireDefault(_remoteHelper);

var _crypt = require('../crypt');

var _crypt2 = _interopRequireDefault(_crypt);

var _confEvents = require('../../conf/events');

var _confEvents2 = _interopRequireDefault(_confEvents);

var wsEvents = _confEvents2['default'].WS.LOCAL,
    remoteEvents = _confEvents2['default'].REMOTE;

var WSClient = (function (_EventEmitter) {
    _inherits(WSClient, _EventEmitter);

    function WSClient(params) {
        _classCallCheck(this, WSClient);

        _get(Object.getPrototypeOf(WSClient.prototype), 'constructor', this).call(this);

        this._secret = params.secret;
        this._prefersEncrypted = params.prefersEncrypted;
        this._crypt = new _crypt2['default'](this._secret);
        this._retryOnDisconnect = params.retryOnDisconnect;
        this._hostname = params.hostname;
        this._webSocketPort = params.websocketPort;
        this._username = params.username;
        this._devbox = new _remoteHelper2['default']({
            secret: this._secret,
            websocketPort: this._webSocketPort,
            username: this._username,
            hostname: this._hostname,
            prefersEncrypted: this._prefersEncrypted,
            debug: this._debug
        });

        this._connect();
    }

    _createClass(WSClient, [{
        key: '_connect',
        value: function _connect() {
            this._ws = new _ws2['default']('ws://' + this._hostname + ':' + this._webSocketPort);
            this._ws.on('open', _lodash2['default'].partial(this.emit.bind(this), wsEvents.READY));
            this._ws.on('close', this._handleDisconnect.bind(this));
            this._ws.on('error', this._reconnect.bind(this));
        }
    }, {
        key: '_handleDisconnect',
        value: function _handleDisconnect() {
            if (this._retryOnDisconnect) {
                return this._reconnect();
            }
            this.emit(wsEvents.DISCONNECTED);
        }
    }, {
        key: '_reconnect',
        value: function _reconnect() {
            this.emit('reconnecting');

            this._devbox.start();
            this._devbox.on(remoteEvents.READY, this._connect.bind(this));
            this._devbox.on(remoteEvents.MESSAGE, _lodash2['default'].partial(this.emit.bind(this), wsEvents.REMOTE_MESSAGE));
            this._devbox.on(remoteEvents.ERROR, _lodash2['default'].partial(this.emit.bind(this), wsEvents.REMOTE_ERROR));
            this._devbox.on(remoteEvents.NOT_FOUND, _lodash2['default'].partial(this.emit.bind(this), wsEvents.REMOTE_NOT_FOUND));
        }
    }, {
        key: 'send',
        value: function send(obj) {
            obj.secret = this._secret;
            this._ws.send(this._crypt.stringifyAndEncrypt(obj, this._prefersEncrypted));
        }
    }]);

    return WSClient;
})(_events.EventEmitter);

exports['default'] = WSClient;
module.exports = exports['default'];