'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ws = require('ws');

var _events = require('events');

var _crypt = require('../crypt');

var _crypt2 = _interopRequireDefault(_crypt);

var _confText = require('../../conf/text');

var _confText2 = _interopRequireDefault(_confText);

var _confEvents = require('../../conf/events');

var wsEvents = _confEvents.WS.REMOTE;

var WSServer = (function (_EventEmitter) {
    _inherits(WSServer, _EventEmitter);

    function WSServer(params) {
        _classCallCheck(this, WSServer);

        _get(Object.getPrototypeOf(WSServer.prototype), 'constructor', this).call(this);

        this._secret = params.secret;
        this._encrypt = params.encrypt;
        this._crypt = new _crypt2['default'](this._secret);

        new _ws.Server({
            port: params.port
        }).on('connection', this.handleConnect.bind(this));

        console.info(this._secret, _confText2['default'].SERVER_ON_READY);
    }

    _createClass(WSServer, [{
        key: 'handleConnect',
        value: function handleConnect(ws) {
            ws.on('message', this.handleMessage.bind(this));
            ws.on('close', this.connectionClosed.bind(this));
        }
    }, {
        key: 'handleMessage',
        value: function handleMessage(message) {
            var parsedMessage = this._crypt.decryptAndParse(message, this._encrypt);

            if (parsedMessage.secret !== this._secret) {
                return this.emit(wsEvents.UNAUTHORIZED);
            }

            /* istanbul ignore else */
            if (parsedMessage.subject === 'file') {
                return this.emit(wsEvents.FILE_CHANGE, parsedMessage);
            }
        }
    }, {
        key: 'connectionClosed',
        value: function connectionClosed() {
            this.emit(wsEvents.CONNECTION_CLOSED);
        }
    }]);

    return WSServer;
})(_events.EventEmitter);

exports['default'] = WSServer;
module.exports = exports['default'];